快捷搜索:

Java编程中异常处理的特殊情况

1、不能在finally块中履行return,continue等语句,否则会把非常“吃掉落”;

2、在try,catch中假如有return语句,则在履行return之前先履行finally块

请大年夜家下面的例子:

public class TryTest {

public static void main(String[] args) {

try {

System.out.println(TryTest.test());// 返回结果为true其没有任何非常

} catch (Exception e) {

System.out.println("Exception from main");

e.printStackTrace();

}

doThings(0);

}

public static boolean test() throws Exception {

try {

throw new Exception("Something error");// 第1步.抛出非常

} catch (Exception e) {// 第2步.捕获的非常匹配(声明类或其父类),进入节制块

System.out.println("Exception from e");// 第3步.打印

return false;// 第5步. return前节制转移到finally块,履行完后再返回(这一步被吃掉落了,不履行)

} finally {

return true; // 第4步. 节制转移,直接返回,吃掉落了非常

}

}

public static void doThings(int i)

{

try

{

if(i==0)

{

//在履行return之前会先履行finally

return;

}

int t=100/i;

System.out.println(t);

}catch(Exception ex)

{

ex.printStackTrace();

}

finally

{

System.out.println("finally");

}

}

}

您可能还会对下面的文章感兴趣: